<?php

add_action( 'admin_enqueue_scripts', 'n02_wc_admin_rezip_scripts' );
function n02_wc_admin_rezip_scripts( $hook ) {

	rezip_product_update();

	if ( $hook != 'woocommerce_page_wc-settings' ) {
		return;
	}
	wp_enqueue_script( 'n02_wc_rezip_settings', plugin_dir_url( __FILE__ ) . '/assets/js/admin/wc.js', [], '1.0' );

}

if ( false ) {

	add_action( 'woocommerce_before_add_to_cart_button', 'n02_before_add_to_cart_btn' );
	function n02_before_add_to_cart_btn() {

		$product_id = get_option( 'rezip-settings-product-id' );
		if ( empty( $product_id ) ) {
			return;
		}

		if ( get_option( 'rezip-type', 'fee' ) == 'product' && ! n02_is_package_in_cart() && n02_is_display_rezip_offer() ) {
			global $product;
			if ( n02_check_product( $product ) ) {
				ob_start();
				include( plugin_dir_path( __FILE__ ) . 'templates/public/product/before-add.php' );
				$output = ob_get_contents();
				ob_end_clean();
				echo $output;
			}
		}

	}

}

add_action( 'woocommerce_remove_cart_item', 'n02_woocommerce_remove_cart_item', 10, 2 );
function n02_woocommerce_remove_cart_item( $cart_item_key, $cart ) {
	$product_id = $cart->cart_contents[ $cart_item_key ]['product_id'];
	$product_id = get_option( 'rezip-settings-product-id' );
	if ( $product_id == get_option( 'rezip-settings-product-id' ) ) {
		WC()->session->set( 'rezip', false );
	}
};

add_action( 'woocommerce_add_to_cart', 'n02_customer_add_to_cart' );
function n02_customer_add_to_cart() {
	if ( get_option( 'rezip-type', 'fee' ) == 'product' ) {
		if ( isset( $_REQUEST['rezip-offer'] ) && $_REQUEST['rezip-offer'] == 'yes' ) {
			unset( $_REQUEST['rezip-offer'] );
			if ( n02_is_display_rezip_offer() ) {
				n02_add_to_cart();
			} else {
				n02_remove_from_cart();
			}
		} else {
			if ( ! n02_is_display_rezip_offer() ) {
				n02_remove_from_cart();
			}
		}
	}
}

// add_action( 'wp', 'n02_page_load' );
add_action( 'template_redirect', 'n02_page_load' );
function n02_page_load() {

	$rezip_type = get_option( 'rezip-type', 'fee' );

	if ( ! n02_is_display_rezip_offer() ) {

		if ( $rezip_type == 'fee' ) {
			WC()->session->set( 'rezip', false );
			n02_remove_fees();
		} else if ( $rezip_type == 'product' ) {
			n02_remove_from_cart();
		}

	} else {

		if ( $rezip_type == 'fee' ) {
			n02_remove_from_cart();
		} else {
			n02_remove_fees();
			$rezip = WC()->session->get( 'rezip', false );
			if ( $rezip ) {
				n02_add_to_cart();
				n02_remove_if_empty();
			}
			n02_set_rezip_quantity();
		}

	}

}

// Redirect to shop page.
// add_action( 'template_redirect', 'n02_template_redirect_rezip_product' );
add_action( 'wp', 'n02_template_redirect_rezip_product' );
function n02_template_redirect_rezip_product() {

	// Flag session if product is detected - fix for undo deletion.
	if ( is_page( 'cart' ) || is_cart() || is_page( 'checkout' ) || is_checkout() ) {
		if ( n02_is_package_in_cart() ) {
			WC()->session->set( 'rezip', true );
		}
	}

	// Disabling
	if ( false && is_product() ) {

		global $post;
		$id = $post->ID;
		$rezip_id = get_option( 'rezip-settings-product-id' );

		if ( $rezip_id == $id ) {
			$redirect_url = get_permalink( get_option('woocommerce_shop_page_id') );
			wp_redirect( $redirect_url );
			exit();
		}

	}

}

// Is Purchasable - Totally disables adding to cart.
if ( false ) {
	add_filter( 'woocommerce_is_purchasable', 'rezip_woocommerce_is_purchasable', 10, 2 );
	function rezip_woocommerce_is_purchasable( $purchasable, $product ) {
		if ( get_option( 'rezip-type', 'fee' ) == 'product' ) {
			$rezip_id = get_option( 'rezip-settings-product-id' );
			if ( $product->get_id() == $rezip_id ) {
				return false;
			}
		}
		return $purchasable;
	}
}

// Update existing REZIP product visibility ( Remove after next update )
function rezip_product_update() {

	if ( ! is_admin() ) {
		return;
	}

	if ( ! function_exists('get_plugin_data') ) {
		require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
	}

	$plugin_data = get_plugin_data( plugin_dir_path(__FILE__ ) . 'plugin.php' );

	if ( $plugin_data['Version'] == '1.1.8' && ! get_option( 'rezip-product-updated' ) ) {

		$product_id = get_option( 'rezip-settings-product-id' );
		$product = wc_get_product( $product_id );
		if ( $product ) {
			$product->set_catalog_visibility( 'visible' );
			$product->save();
			// ! d( 'UPDATE PRODUCT', $plugin_data, $product_id );
		}
		add_option( 'rezip-product-updated', true );

	}

}
