<?php

function n02_get_user_roles() {

	global $wp_roles;

	$roles = [];
	foreach ( $wp_roles->roles as $index => $role ) {
		$roles[ $index ] = $role['name'];
	}

	// ddd( $wp_roles->roles, $roles );
	return $roles;

}

function n02_get_product_tags() {

	$terms = get_terms( 'product_tag' );
	$term_array = [];
	if ( ! empty( $terms ) && ! is_wp_error( $terms ) ){
		foreach ( $terms as $term ) {
			// d( $term, $term->term_id );
			$term_array[ $term->term_id ] = $term->name;
		}
	}

	// ddd( $term_array );
	return $term_array;

}

function n02_is_display_rezip_offer() {

	global $woocommerce;

	$flag_display = true;

	$role_value = get_option( 'rezip-disable-user-role-value', [] );
	if ( get_option( 'rezip-disable-user-role' ) == 'yes' && sizeof( $role_value ) ) {

		$user = wp_get_current_user();
		if ( sizeof( $user->roles ) ) {
			$roles = $user->roles;
		} else {
			$roles[] = 'customer';
		}

		foreach ( $roles as $role ) {
			if ( in_array( $role, $role_value ) ) {
				$flag_display = false;
			}
		}

	}

	$weight_value = get_option( 'rezip-disable-weight-value', null );
	if ( $flag_display && get_option( 'rezip-disable-weight' ) == 'yes' && ! empty( $weight_value ) ) {
		$items = $woocommerce->cart->get_cart();
		$total_weight = 0;
		foreach( $items as $item => $values ) {
			// Simple, Variation
			$product_id = $values['product_id'];
			if ( isset( $values['variation_id'] ) && ! empty( $values['variation_id'] ) ) {
				$product_id = $values['variation_id'];
			}
			// d( $values, $product_id );
			$product = wc_get_product( $product_id );
			if ( $product && method_exists( $product , 'get_weight' ) && ! empty( $values['data']->get_weight() ) ) {
				if ( $product->get_weight() ) {
					$total_weight += ( $product->get_weight() * $values['quantity'] );
					// d( $values, $product->get_weight(), $values['data'], $total_weight );
				}
			}
		}
		// d( $total_weight, $weight_value );
		if ( $total_weight >= $weight_value ) {
			$flag_display = false;
		}
	}

	$tag_value = get_option( 'rezip-disable-product-tags-value', [] );
	if ( $flag_display && get_option( 'rezip-disable-product-tags' ) == 'yes' && sizeof( $tag_value ) ) {
		$items = $woocommerce->cart->get_cart();
		foreach( $items as $item => $values ) {
			// Simple, Variation
			$product_id = $values['product_id'];
			if ( isset( $values['variation_id'] ) && ! empty( $values['variation_id'] ) ) {
				$product_id = $values['variation_id'];
			}
			$product = wc_get_product( $values['product_id'] );
			$product_tags = $product->get_tag_ids();
			// d( $product, $product_tags );
			if ( $product_tags ) {
				foreach( $tag_value as $tag ) {
					if ( in_array( $tag, $product_tags ) ) {
						$flag_display = false;
					}
				}
			}

		}
	}

	// if ( ! $flag_display ) {
	// 	// d( 13 );
	// 	if ( get_option( 'rezip-type', 'fee' ) == 'fee' ) {
	// 		n02_remove_fees();
	// 	} else {
	// 		n02_remove_from_cart();
	// 	}
	// }

	return $flag_display;

}

function n02_remove_fees() {
	$cart_fee_api = WC()->cart->fees_api();
	$fees = $cart_fee_api->get_fees();
	if ( isset( $fees['re-zip-emballage'] ) ) {
		// wc_print_notice( 'Removing REZIP.', 'notice' );
		unset( $fees['re-zip-emballage'] );
		$cart_fee_api->set_fees( $fees );
		WC()->session->set( 'rezip', false );
		WC()->cart->calculate_totals();
	}
}

function n02_get_rezip_type() {
	return get_option( 'rezip-type', 'fee' );
}

// Product Type
if ( true ) {

	// Create Product
	function n02_create_product_rezip() {

		require_once( ABSPATH . 'wp-admin/includes/media.php' );
		require_once( ABSPATH . 'wp-admin/includes/file.php' );
		require_once( ABSPATH . 'wp-admin/includes/image.php' );

		$url = 'https://app.re-zip.dk/img/rezip_emballage.png';
		$media_id = media_sideload_image( $url, 1, 'REZIP', 'id' );

		$post_id = wp_insert_post( [
			'post_title'   => 'RE-ZIP emballage',
			'post_content' => 'Vælg cirkulær emballage og få rabat ved næste køb.',
			'post_status'  => 'publish',
			'post_type'    => "product",
		] );

		wp_set_object_terms( $post_id, 'simple', 'product_type' );

		update_post_meta( $post_id, '_price', '15' );
		update_post_meta( $post_id, '_stock_status', 'instock');
		update_post_meta( $post_id, '_sku', 'rezip' );

		// Image
		update_post_meta( $post_id, '_thumbnail_id', $media_id );

		update_post_meta( $post_id, '_visibility', 'visible' );
		update_post_meta( $post_id, '_stock_status', 'instock');
		update_post_meta( $post_id, 'total_sales', '0' );
		update_post_meta( $post_id, '_regular_price', '15' );

		// update_post_meta( $post_id, '_downloadable', 'no' );
		// update_post_meta( $post_id, '_virtual', 'yes' );
		// update_post_meta( $post_id, '_sale_price', '' );
		// update_post_meta( $post_id, '_purchase_note', '' );
		// update_post_meta( $post_id, '_featured', 'no' );
		// update_post_meta( $post_id, '_weight', '' );
		// update_post_meta( $post_id, '_length', '' );
		// update_post_meta( $post_id, '_width', '' );
		// update_post_meta( $post_id, '_height', '' );
		// update_post_meta( $post_id, '_sku', '' );
		// update_post_meta( $post_id, '_product_attributes', array() );
		// update_post_meta( $post_id, '_sale_price_dates_from', '' );
		// update_post_meta( $post_id, '_sale_price_dates_to', '' );
		// update_post_meta( $post_id, '_price', '' );
		// update_post_meta( $post_id, '_sold_individually', '' );
		// update_post_meta( $post_id, '_manage_stock', 'no' );
		// update_post_meta( $post_id, '_backorders', 'no' );

		// $terms = [ 'exclude-from-catalog', 'exclude-from-search' ];
		// wp_set_object_terms( $post_id, $terms, 'product_visibility' );

		return $post_id;

	}

	// Add to Cart
	function n02_add_to_cart() {
		if ( ! n02_is_package_in_cart() ) {
			$id = get_option( 'rezip-settings-product-id' );
			if ( $id ) {
				WC()->cart->add_to_cart( $id );
			}
		}
	}

	function n02_check_product( $product ) {


		$flag_display = true;

		$role_value = get_option( 'rezip-disable-user-role-value', [] );
		if ( get_option( 'rezip-disable-user-role' ) == 'yes' && sizeof( $role_value ) ) {

			$user = wp_get_current_user();
			if ( sizeof( $user->roles ) ) {
				$roles = $user->roles;
			} else {
				$roles[] = 'customer';
			}

			foreach ( $roles as $role ) {
				if ( in_array( $role, $role_value ) ) {
					$flag_display = false;
				}
			}

		}

		$weight_value = get_option( 'rezip-disable-weight-value', null );
		if ( $flag_display && get_option( 'rezip-disable-weight' ) == 'yes' && ! empty( $weight_value ) ) {
			if ( ! empty( $product->get_weight() ) ) {
				if ( ( WC()->cart->cart_contents_weight + $product->get_weight() ) >= $weight_value ) {
					$flag_display = false;
				}
			}
		}

		$tag_value = get_option( 'rezip-disable-product-tags-value', [] );
		if ( $flag_display && get_option( 'rezip-disable-product-tags' ) == 'yes' && sizeof( $tag_value ) ) {
			$tags = $product->get_tag_ids();
			if ( $tags ) {
				foreach( $tag_value as $tag ) {
					// ! d( $tag, $values['data']->tag_ids );
					if ( in_array( $tag, $tags ) ) {
						$flag_display = false;
					}
				}
			}
		}

		return $flag_display;

	}

	function n02_is_package_in_cart() {
		$product_id = get_option( 'rezip-settings-product-id' );
		if ( $product_id ) {
			// Fix for "WooCommerce Product Add-ons"
			$cart_items = WC()->cart->get_cart_contents();
			if ( sizeof( $cart_items ) ) {
				foreach ( $cart_items as $item ) {
					if ( $item['product_id'] == $product_id ) {
						return true;
					}
				}
			}
		}
		return false;
	}

	// Remove
	function n02_remove_from_cart() {
		$product_id = get_option( 'rezip-settings-product-id' );
		if ( $product_id ) {

			$cart_items = WC()->cart->get_cart_contents();
			if ( sizeof( $cart_items ) ) {
				foreach ( $cart_items as $cartItemKey => $item ) {
					if ( $item['product_id'] == $product_id ) {
						// wc_print_notice( 'Removing REZIP due to restrictions', 'notice' );
						WC()->cart->remove_cart_item( $cartItemKey );
					}
				}
			}

			// $cartId = WC()->cart->generate_cart_id( $product_id );
			// $cartItemKey = WC()->cart->find_product_in_cart( $cartId );
			// if ( $cartItemKey ) {
			// 	wc_print_notice( 'Removing REZIP due to restrictions', 'notice' );
			// 	WC()->cart->remove_cart_item( $cartItemKey );
			// }

		}
	}

	// Set Package Quantity to 1
	function n02_set_rezip_quantity() {

		$product_id = get_option( 'rezip-settings-product-id' );
		if ( $product_id ) {

			$cart_items = WC()->cart->get_cart_contents();
			if ( sizeof( $cart_items ) ) {
				foreach ( $cart_items as $cartItemKey => $item ) {
					if ( $item['product_id'] == $product_id ) {
						WC()->cart->set_quantity( $cartItemKey, 1 );
					}
				}
			}

			// $cartId = WC()->cart->generate_cart_id( $product_id );
			// $cartItemKey = WC()->cart->find_product_in_cart( $cartId );
			// if ( $cartItemKey ) {
			// 	WC()->cart->set_quantity( $cartItemKey, 1 );
			// }

		}

	}

	// Remove REZIP product if it is the only item on the cart.
	function n02_remove_if_empty() {
		$product_id = get_option( 'rezip-settings-product-id' );
		if ( $product_id ) {
			$cart_items = WC()->cart->get_cart_contents();
			if ( sizeof( $cart_items ) == 1 ) {
				foreach ( $cart_items as $cartItemKey => $item ) {
					if ( $item['product_id'] == $product_id ) {
						WC()->cart->remove_cart_item( $cartItemKey );
						$message = sprintf( __( '%s removed.', 'woocommerce' ), 'RE-ZIP' );
						wc_add_notice( $message, 'notice' );
					}
				}
			}
		}
	}

}
