<?php namespace MTTPlugin\Lib\Abstracts;

abstract class Controller {

	public function __construct() {
		$this->registerActions();
		$this->registerFilters();

		if(is_admin()) {
			$this->registerActionsAdmin();
			$this->registerFiltersAdmin();
		}
	}

	protected function registerActions() {

	}

	protected function registerFilters() {

	}

	protected function registerActionsAdmin() {

	}

	protected function registerFiltersAdmin() {

	}
}
