<?php namespace MTTPlugin\Lib\Abstracts;

use MTTPlugin\Lib\Tools\Admin\Notice\NoticeFactory;
use MTTPlugin\Lib\Tools\Loader;

abstract class PluginAdmin extends PluginPart {

	use \MTTPlugin\Lib\Tools\Admin\AdminPageFactory;

	protected static $dir_namespace = 'admin';

	public $settings_factory;

	protected static $plugin;

	public function __construct($plugin) {
		parent::__construct($plugin);

		$this->adminPageFactoryInit();

		$this->registerAdminPages();
		$this->registerSettings();
		$this->registerModels();
		$this->initTools();
	}

	public function initTools() {
		NoticeFactory::init();
	}

	public function registerModels() {

	}

	public function registerHooks() {
		parent::registerHooks();

		Loader::addAction('admin_init', $this, 'registerSettings');
		Loader::addAction('admin_enqueue_scripts', $this, 'enqueueStyles');
		Loader::addAction('admin_enqueue_scripts', $this, 'enqueueScripts');
	}
	
	public function registerFilters() {
		parent::registerFilters();
		
		Loader::addFilter('set-screen-option', __NAMESPACE__ . '\Admin\AdminTable', 'setScreenOption', 10, 3);
	}

	public function registerAdminPages() {

	}

	public function registerSettings() {

	}

	public function enqueueStyles() {
	}

}