<?php namespace MTTPlugin\Lib\Abstracts;

use MTTPlugin\Lib\Tools\Loader;

abstract class PluginPart {

    use \MTTPlugin\Lib\Traits\Templating;
    use \MTTPlugin\Lib\Traits\Translate;

	protected static $plugin;

	protected static $dir_namespace;

	protected static $instance = null;

	public function __construct($plugin) {
		static::$plugin = $plugin;

		$this->registerHooks();

		$this->registerFilters();

		static::$instance = $this;
	}

	// GETTERS
    public static function getRoot() {
        return static::$plugin->getRoot();
    }

    public static function getVersion() {
        return static::$plugin->getVersion();
    }

    public static function getTextDomain() {
        return static::$plugin->getTextDomain();
    }

    public static function getInstance() {
		return static::$instance;
    }


	public function startSession() {
		if(!session_id()) {
			session_start();
		}
	}



	public function registerHooks() {

	}

	public function registerFilters() {

	}

	public function enqueueStyles() {

	}

	public function enqueueScripts() {

	}
}