<?php namespace MTTPlugin\Lib\Tools\Admin\Settings;

class SettingsSection {

	private $id;
	private $title;
	private $content_component;
	private $content_callback;
	private $page_slug;
	private $content;

	private $plugin_admin;

	public function __construct($plugin, $args) {
		$this->plugin_admin = $plugin;

		$this->addSettingsSectionInfo($args);
	}
	
	public function addSettingsSectionInfo(array $settings_section_info = []) {
		$defaults = [
			'id' => 'settings-section',
			'title' => $this->plugin_admin->translate('Settings Section'),
			'content_component' => $this,
			'content_callback' => 'displayContent',
			'page_slug' => 'admin-page',
			'content' => '',
		];

		$settings_section_info = \wp_parse_args($settings_section_info, $defaults);

		foreach($settings_section_info as $key => $info) {
			if(property_exists($this, $key)) {
				$this->{$key} = $info;
			}
		}
	}

	public function registerSettings() {
		\add_settings_section($this->id, $this->title, array($this->content_component, $this->content_callback), $this->page_slug);
	}

	public function displaySettings() {
		$this->plugin_admin->getTemplate('parts.settings-section', ['settings_section_id' => $this->id, 'page_slug' => $this->page_slug]);
	}

	public function addSettingsField($id, $title, array $args = array()) {
		$this->plugin_admin->addSettingsField($id, $title, $this->page_slug, $this->id, $args);
	}

	public function addSettingsFields(array $settings_fields) {
		$this->plugin_admin->addSettingsFields($this->page_slug, $this->id, $settings_fields);
	}

	public function displayContent() {
		$this->plugin_admin->getTemplate('parts.settings-section-content', array('content' => $this->content));
	}

}