<?php namespace MTTPlugin\Lib\Tools;

class Error {

	protected static $errors = array();

	protected $name = '';

	protected $message = '';

	public function __construct($name, $message) {
		$this->name = $name;
		$this->message = $message;
	}

	public function getName() {
		return $this->name;
	}

	public function getMessage() {
		return $this->message;
	}

	public static function getAll() {
		return static::$errors;
	}

	public static function get($name) {
		if(isset(static::getAll()[$name])) {
			return static::getAll()[$name];
		}
		return null;
	}

	public static function setError($name, $message) {
		static::setErrors(array($name => $message));
	}

	public static function setErrors($errors) {
		static::$errors = array_merge(static::$errors, $errors);

		if(isset($_SESSION['errors'])) {
			$_SESSION['errors'] = array_merge((array) $_SESSION['errors'],  static::$errors);
		} else {
			$_SESSION['errors'] = static::$errors;
		}
	}

	protected static function loadErrors() {
		if(isset($_SESSION['errors'])) {
			foreach((array) $_SESSION['errors'] as $name => $message) {
				static::$errors[$name] = new self($name, $message);
			}
			unset($_SESSION['errors']);
		}
	}

	protected static function startSession() {
		if(!session_id()) {
			session_start();
		}
	}

	public static function init() {
		Loader::addAction('init', __CLASS__, 'start');
	}

	public static function start() {
		static::startSession();
		static::loadErrors();
	}
}